#include <stdio.h>
#include <stdlib.h>

typedef struct n {
        int val;
        struct n * left;
		struct n * right;
} nodo;
typedef nodo * Albero;

Albero createVal(int val);
Albero creaAlbero1();Albero creaAlbero2();Albero creaAlbero3();
void print(Albero t);
void stampa(Albero T);
int maxOccorrenze(Albero TA, Albero TB, int *valore);
int contaOccorrenze(Albero T, Albero nod);

int main(){
    int ris=0, valore = -1;
    Albero T1,T2,T3;
    T1 = creaAlbero1(); T2 = creaAlbero2(); T3 = creaAlbero3();
    printf("\nT1: "); stampa(T1);
    printf("\nT2: "); stampa(T2);
    printf("\nT3: "); stampa(T3);

    //
    // TODO: SVILUPPARE QUI DENTRO QUANTO RICHIESTO
    //

 	//FUNZIONI AUSILIARIE CON PARAMETRI DIVERSI SONO MOLTO CONSIGLIATE

    printf("\nmax occorrenze di T1 in T2: %d appare %d volte", valore, maxOccorrenze(T1, T2, &valore));
    printf("\nmax occorrenze di T2 in T1: %d appare %d volte", valore, maxOccorrenze(T2, T1, &valore));
    printf("\nmax occorrenze di T1 in T3: %d appare %d volte", valore, maxOccorrenze(T1, T3, &valore));
    printf("\nmax occorrenze di T2 in T3: %d appare %d volte", valore, maxOccorrenze(T2, T3, &valore));

   //printf("\n occorrenze di %d in T3: %d", T1->left->val, contaOccorrenze(T3, T1->left));

    return 0;
}



int maxOccorrenze(Albero TA, Albero TB, int *valore)
{
    int occ, occL, occR, massimo, valL, valR;

    if(TA==NULL)
		return 0;

    *valore = TA->val;
    occ = contaOccorrenze(TB, TA);
    //printf("\n occ: %d, valore: %d", occ, *valore);

    occL = maxOccorrenze(TA->left, TB, &valL);
    //printf("\n occL: %d, valL: %d", occL, valL);

    occR = maxOccorrenze(TA->right, TB, &valR);
    //printf("\n occR: %d, valR: %d", occR, valR);


    massimo = occ;


   if(massimo < occL && TA->left != NULL)
   {
         *valore = valL;
         massimo = occL;
   }

   if(massimo < occR && TA->right != NULL)
   {
         *valore = valR;
         massimo = occR;
   }

   return massimo;

}

int max3(int a, int b, int c)
{
    return max(max(a, b), c);
}

int max(int a, int b)
{
    if(a > b)
        return a;
    return b;
}

int contaOccorrenze(Albero T, Albero nod)
{
    if(T==NULL)
		return 0;

    if (nod == NULL)
        return 0;

	if(T->val == nod->val)
		return 1 + contaOccorrenze(T->left, nod) + contaOccorrenze(T->right, nod);
	else
		return contaOccorrenze(T->left, nod) + contaOccorrenze(T->right, nod);

}



Albero creaAlbero1() {
    Albero tmp = createVal(7);
    tmp->left = createVal(3);tmp->left->left = createVal(9);tmp->left->right = createVal(10);
    tmp->right = createVal(8);tmp->right->left = createVal(5);tmp->right->right = createVal(12);
    tmp->right->right->left = createVal(11); tmp->right->right->right = createVal(9);
    return tmp;
}

Albero creaAlbero2() {
    Albero tmp = createVal(7);
    tmp->right = createVal(7);tmp->right->right = createVal(9);tmp->right->left = createVal(10);
    tmp->left = createVal(7);tmp->left->right = createVal(9);tmp->left->left = createVal(12);
    tmp->left->left->right = createVal(11);tmp->left->left->left = createVal(6);
    return tmp;
}

Albero creaAlbero3() {
    Albero tmp = createVal(3);
    tmp->right = createVal(3);tmp->right->right = createVal(9);tmp->right->left = createVal(10);
    tmp->left = createVal(4);tmp->left->right = createVal(3);tmp->left->left = createVal(12);
    tmp->left->left->right = createVal(2);tmp->left->left->left = createVal(6);
    return tmp;
}

void print(Albero t){
       if(t==NULL)return;
       else{printf(" (");print(t->left);printf(" %d ",t->val);print(t->right);printf(") ");}
}

void stampa(Albero T){print(T);printf("\n");}

Albero createVal(int val) {
    Albero tmp = malloc(sizeof(nodo));
    tmp->val = val;    tmp->left = NULL;    tmp->right = NULL;
    return tmp;
}
